﻿/*Class that has all the stuff specific to puzzle pieces
* */

class Ball {
	private var speed:Number;
	private var xDirection:Number;
	private var yDirection:Number;
	
	//bounding box of where pieces bounce
	private var stageTop:Number = 12;
	private var stageBottom:Number = 340;
	private var stageLeft:Number = 12;
	private var stageRight:Number = 538;

	
	private var mc:MovieClip;
	
	//bounding box of the drop zone
	private var dropTop:Number = 350;
	private var dropBottom:Number = 400;
	private var dropLeft:Number = 0;
	private var dropRight:Number = 538;
	
	private var dropped:Boolean;
	private var dragged:Boolean;
	
	public var ind:Number;
	private var arr_i:Number;
	
	private var parent:MovieClip;
	
	private var bm:BallManager; 
	
	public var variant:Number; 
	
	public function Ball(ind:Number, arr_i:Number, variant:Number, parent:MovieClip, bm:BallManager) {

		this.bm = bm;
		
		this.ind = ind;  //index of puzzle piece symbol name
		this.arr_i = arr_i;
		this.parent = parent;
		
		var depth:Number = parent.getNextHighestDepth();
		this.mc = parent.attachMovie("p"+this.ind, "p"+this.ind, depth);
		
		//trace("attached piece p"+this.ind+" at depth "+depth);
		
		this.mc._x = 50+Math.random()*200;
		this.mc._y = 50+Math.random()*300;
		
		this.mc._xscale = 95;
		this.mc._yscale = 95;
		this.mc.xDirection = 1;
		this.mc.yDirection = 1;
		this.mc.speed = .5+Math.random()*variant;
		this.mc._alpha = 60;
		
		this.mc.dropped = false;
		this.mc.dragged = false;
	}
	
		/**
	 * move instructions; called every frame
	 */
	public function moveMC() :Void {
		this.mc.onPress= Proxy.create(this, this.onButtonPress);//mouse's been pressed
		
		this.mc.onRelease = this.mc.onReleaseOutside = Proxy.create(this, this.onButtonRelease); //mouse's been released
				
		this.move();
				
	
	}

	
	//drags on mouse press
	private function onButtonPress():Void{
		//don't drag if already been dropped
		if(this.mc.dropped){
			return;
		}
		
		
		this.mc.startDrag(true);
		this.mc.dragged = true;
	}
	
	//stops dragging on mouse release and checks if inside drop zone
	private function onButtonRelease():Void{
		
		this.mc.stopDrag();
		this.checkDropZone();
	}
	
	private function checkDropZone():Void{
		this.mc.dragged = false;
		
		//trace(this.mc._x+" / "+this.dropRight);
		
		//if inside drag zone, stay there
		if(this.mc._x < this.dropRight && this.mc._x > this.dropLeft && this.mc._y < this.dropBottom && this.mc._y > this.dropTop){
			
			this.mc._y = 380;
			
			this.mc.dropped = true;
			
			trace("DROPPED: "+this.arr_i+"/"+this.ind);
			
			this.mc._xscale = 92;
			this.mc._yscale = 92;
			this.mc._alpha = 100;
			
			bm.checkCollision(this.arr_i); //DOES NOT GET CALLED EVERY TIME!!! 
			
		}
		
		
		
		
	}
	
	//takes care of piece bouncing around
	private function move():Void {
		
		if(this.mc.dropped || this.mc.dragged){
			return;
		}
		this.mc._x += (this.mc.speed*this.mc.xDirection);
		this.mc._y += (this.mc.speed*this.mc.yDirection);
		if (this.mc._x>this.stageRight) {
			this.mc.xDirection = -1;
		} else if (this.mc._x<this.stageLeft) {
			this.mc.xDirection = 1;
		} else if (this.mc._y<this.stageTop) {
			this.mc.yDirection = 1;
		} else if (this.mc._y>this.stageBottom) {
			this.mc.yDirection = -1;
		}
	}
	
	public function killMe():Void {
		
		//trace("REMOVED!!!!");
		this.mc.removeMovieClip();
	}
	
	public function get x () :Number { return this.mc._x; }
	public function set x (val:Number) { this.mc._x = val; }
	
	public function get y () :Number { return this.mc._y; }
	public function set y (val:Number) { this.mc._y = val; }
}
