﻿class BallManager {
	private var totalBalls:Number = 20; //total number of puzzle pieces on screen at a time
	private var container:MovieClip;			//container mc holds all pieces

	private var score:Number;			//will keep track of score, does nothing now
	private var ball:Ball;              //puzzle piece, used to be a ball
	private var totalPieces:Number = 8; //total number of differenc puzzle pieces
	private var pieces:Array = [];			//store all pieces instances here
	private var index:Number;            //piece symbol number 
	private var arr_i:Number; 				//index into array of pieces
	
	private var root:MovieClip;      //reference to root
	
	private var targetManager:TargetManager;
	
	private var scoreDisplay:ScoreDisplay;		//reference to the ScoreDisplay
	
	private var variant:Number = 2;
	
	
	
	function BallManager(root:MovieClip) {
		
		this.root = root;
		this.init();
	}
	
	public function storeReferences(targetManager:TargetManager, sd:ScoreDisplay){
		this.targetManager = targetManager;
		this.scoreDisplay = sd;
	    
	}
	
	//creates an array of pieces 
	private function init():Void {
		
		//trace("initiating ball manager");
		this.container = _root.createEmptyMovieClip("ballMgr", _root.getNextHighestDepth());
		
		for (var i = 0; i<this.totalBalls; i++) { //creates 15 pieces
			
			
			this.index = i%totalPieces; //index goes to only 0-7
						
			//creates new piece and places it into an array
			this.ball = new Ball(this.index, i, variant, this.container, this);  
			pieces[i] = this.ball;
			
		}
	}
	
	
	//generates new puzzle piece, but will check for collision with a proper target and update the score
	public function checkCollision(i:Number):Void {
		
		trace("CHECKED!");
		
		var target = this.targetManager.tars;
		
		this.arr_i = i;
		
	
		//right now, checks against hit with any target
		for(var j = 0; j < target.length; j++){
			
						
			if (Math.abs(pieces[i].x - target[j].x)<15){
				{
					if (pieces[i].ind == target[j].ind){
						
					
					
						target[j].mc._alpha = 0;
				        this.scoreDisplay.add(1);
					}
				}
				
				//trace("Hit!");
				
				
				
			}
		}
	
		
		pieces[i].killMe(); // removes game piece movie clip
		addElement(i); //swaps array member with a new piece
		
		
	}

	
	
	public function addElement(i):Void{
		
		if(scoreDisplay.score >10){variant = 3;}
		else if(scoreDisplay.score >25){variant = 4;}
		else if(scoreDisplay.score >40){variant = 5;}
		else if(scoreDisplay.score >55){variant = 6;}
		
		//trace("adding element");
		//this.container = _root.createEmptyMovieClip("tarMgr", _root.getNextHighestDepth());
		this.index = Math.floor(Math.random()*this.totalPieces);
		//trace(this.index);
		this.ball = new Ball(this.index, i, variant, this.container, this); //add new target
	
		pieces.splice(i, 1, this.ball);
		trace(pieces[i].mc);
		
		
	}
	
	//called on every frame
	public function killAll():Void{
		
		this.scoreDisplay.killMe();
		
		
		for(var i = 0; i<this.pieces.length; i++){
			
			pieces[i].killMe();
			_root.gotoAndPlay("splash");
		}
	}
	
	//gets called from main on every frame. Updates movement for every peice in array
	public function update():Void{
		for(var i = 0; i<this.totalBalls; i++){
			pieces[i].moveMC();
		}
	}
	
}
