﻿class Main {
	private var root:MovieClip;			//store a reference to the _root timeline
	private var oefMC:MovieClip;		//a MovieClip dedicated solely to executing the main loop onEnterFrame
	private var ballManager:BallManager;	//reference to BallManager instance
	private var targetManager:TargetManager; // reference to TargetManager instance

	
	private var SCORE_DEPTH:Number = 100;				//depth of score display
	private var REMAIN_DEPTH:Number = 200;				//depth of time display
	
	private var scoreDisplay:ScoreDisplay;				//reference to ScoreDisplay instance
	private var remainDisplay:RemainDisplay;				//reference to ScoreDisplay instance


	
	private var startPromptMC:MovieClip;	//start prompt MovieClip

	
	public function Main (root:MovieClip) {
		this.root = root;
	
		this.init();
	    this.start();
	}
	
	//creates ball manager and target manager instances
	private function init () :Void {
		
		this.targetManager = new TargetManager(this.root);
		this.ballManager = new BallManager(this.root);
		this.scoreDisplay = new ScoreDisplay(this.root, this.SCORE_DEPTH);
		this.remainDisplay = new RemainDisplay(this.root, this.REMAIN_DEPTH);
		this.ballManager.storeReferences(this.targetManager, this.scoreDisplay);
		this.targetManager.storeReferences(this.ballManager, this.remainDisplay);
		
	}
	

	
	/**
	 * start the onEnterFrame main application loop
	 */
	private function start () :Void {
		this.oefMC = this.root.createEmptyMovieClip("oefMC", this.root.getNextHighestDepth());
		this.oefMC.onEnterFrame = Proxy.create(this, this.update);
		this.update();
	}
	
	/**
	 * the main application loop;
	 * executed onEnterFrame.
	 * updates ball manager and target manager
	 */
	private function update () :Void {
		this.ballManager.update();
		this.targetManager.update();
	}
	
	
}