﻿//responsible for creating and moving the targets

class TargetManager {
	private var totalTars:Number = 15; //total number of targets on screen at a time
	private var container:MovieClip;			//container mc holds all pieces

	private var target:Target;   
	private var difTars:Number = 8; //total number of different types of targets
	public var tars:Array = [];			//store all pieces instances here
	private var index:Number;        //will take care of target symbol index
	
	private var root:MovieClip;
	
	private var remainDisplay:RemainDisplay;		//reference to the RemainDisplay
	private var ballManager:BallManager;
	
	function TargetManager(root:MovieClip) {
		
		this.root = root;
		this.init();
	}
	
	public function storeReferences(bm:BallManager, rd:RemainDisplay){
		this.remainDisplay = rd;
		this.ballManager = bm;
	
	}
	
	
	private function init():Void {
		
		//trace("initiating target manager");
		this.container = _root.createEmptyMovieClip("tarMgr", _root.getNextHighestDepth());
		
		//creates new targets in a random order and places them into the array
		for (var i = 0; i<this.totalTars; i++) {
			
			this.index = Math.floor(Math.random()*this.difTars);
			
			//trace(this.index);
			
			this.target = new Target(this.index, this.container);
			this.target.x = (i*50)+500; //x position -- there are issues with this
			this.target.y = 380; //y is always the same
			tars[i] = this.target;
			
		}
	}

	
	//called on every frame
	public function update():Void{
		
		
		
		for(var i = 0; i<this.tars.length; i++){
			
			tars[i].moveMC();
			
			//if its off the screen 
			if(tars[i].x < -0){
				
			
				if(tars[i].mc._alpha > 0){
					this.remainDisplay.sub(1);
					if(this.remainDisplay.score <= 0){
					
						killAll();
					}
				}
				var ex = tars[i].x;
				//add another random element
				tars[i].killMe();
				addElement(i, ex);
			}
		}
	}
	
	//called on every frame
	public function killAll():Void{
		
		this.remainDisplay.killMe();
		this.ballManager.killAll();
		
		
		for(var i = 0; i<this.tars.length; i++){
			
			tars[i].killMe();
			_root.gotoAndPlay("over");
		}
	}
			
	
	
	
	
	public function addElement(i, ex):Void{
		
		
		
		//trace("adding element");
		//this.container = _root.createEmptyMovieClip("tarMgr", _root.getNextHighestDepth());
		this.index = Math.floor(Math.random()*this.difTars);
		//trace(this.index);
		this.target = new Target(this.index, this.container); //add new target
		trace(550+ex);
		this.target.x = 650+ i+100; 
		this.target.y = 380;
		
		tars.splice(i, 1, this.target);
		
		
	}
	
	
	
}
